require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe BalloonTemplatesController do

  # This should return the minimal set of attributes required to create a valid
  # BaloonTemplate. As you add validations to BaloonTemplate, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all baloon_templates as @baloon_templates" do
      baloon_template = BaloonTemplate.create! valid_attributes
      get :index
      assigns(:baloon_templates).should eq([baloon_template])
    end
  end

  describe "GET show" do
    it "assigns the requested baloon_template as @baloon_template" do
      baloon_template = BaloonTemplate.create! valid_attributes
      get :show, :id => baloon_template.id
      assigns(:baloon_template).should eq(baloon_template)
    end
  end

  describe "GET new" do
    it "assigns a new baloon_template as @baloon_template" do
      get :new
      assigns(:baloon_template).should be_a_new(BaloonTemplate)
    end
  end

  describe "GET edit" do
    it "assigns the requested baloon_template as @baloon_template" do
      baloon_template = BaloonTemplate.create! valid_attributes
      get :edit, :id => baloon_template.id
      assigns(:baloon_template).should eq(baloon_template)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new BaloonTemplate" do
        expect {
          post :create, :baloon_template => valid_attributes
        }.to change(BaloonTemplate, :count).by(1)
      end

      it "assigns a newly created baloon_template as @baloon_template" do
        post :create, :baloon_template => valid_attributes
        assigns(:baloon_template).should be_a(BaloonTemplate)
        assigns(:baloon_template).should be_persisted
      end

      it "redirects to the created baloon_template" do
        post :create, :baloon_template => valid_attributes
        response.should redirect_to(BaloonTemplate.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved baloon_template as @baloon_template" do
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonTemplate.any_instance.stub(:save).and_return(false)
        post :create, :baloon_template => {}
        assigns(:baloon_template).should be_a_new(BaloonTemplate)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonTemplate.any_instance.stub(:save).and_return(false)
        post :create, :baloon_template => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested baloon_template" do
        baloon_template = BaloonTemplate.create! valid_attributes
        # Assuming there are no other baloon_templates in the database, this
        # specifies that the BaloonTemplate created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        BaloonTemplate.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => baloon_template.id, :baloon_template => {'these' => 'params'}
      end

      it "assigns the requested baloon_template as @baloon_template" do
        baloon_template = BaloonTemplate.create! valid_attributes
        put :update, :id => baloon_template.id, :baloon_template => valid_attributes
        assigns(:baloon_template).should eq(baloon_template)
      end

      it "redirects to the baloon_template" do
        baloon_template = BaloonTemplate.create! valid_attributes
        put :update, :id => baloon_template.id, :baloon_template => valid_attributes
        response.should redirect_to(baloon_template)
      end
    end

    describe "with invalid params" do
      it "assigns the baloon_template as @baloon_template" do
        baloon_template = BaloonTemplate.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonTemplate.any_instance.stub(:save).and_return(false)
        put :update, :id => baloon_template.id, :baloon_template => {}
        assigns(:baloon_template).should eq(baloon_template)
      end

      it "re-renders the 'edit' template" do
        baloon_template = BaloonTemplate.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonTemplate.any_instance.stub(:save).and_return(false)
        put :update, :id => baloon_template.id, :baloon_template => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested baloon_template" do
      baloon_template = BaloonTemplate.create! valid_attributes
      expect {
        delete :destroy, :id => baloon_template.id
      }.to change(BaloonTemplate, :count).by(-1)
    end

    it "redirects to the baloon_templates list" do
      baloon_template = BaloonTemplate.create! valid_attributes
      delete :destroy, :id => baloon_template.id
      response.should redirect_to(baloon_templates_url)
    end
  end

end
