require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SpeachBalloonsController do

  # This should return the minimal set of attributes required to create a valid
  # SpeachBaloon. As you add validations to SpeachBaloon, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all speach_baloons as @speach_baloons" do
      speach_baloon = SpeachBaloon.create! valid_attributes
      get :index
      assigns(:speach_baloons).should eq([speach_baloon])
    end
  end

  describe "GET show" do
    it "assigns the requested speach_baloon as @speach_baloon" do
      speach_baloon = SpeachBaloon.create! valid_attributes
      get :show, :id => speach_baloon.id
      assigns(:speach_baloon).should eq(speach_baloon)
    end
  end

  describe "GET new" do
    it "assigns a new speach_baloon as @speach_baloon" do
      get :new
      assigns(:speach_baloon).should be_a_new(SpeachBaloon)
    end
  end

  describe "GET edit" do
    it "assigns the requested speach_baloon as @speach_baloon" do
      speach_baloon = SpeachBaloon.create! valid_attributes
      get :edit, :id => speach_baloon.id
      assigns(:speach_baloon).should eq(speach_baloon)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new SpeachBaloon" do
        expect {
          post :create, :speach_baloon => valid_attributes
        }.to change(SpeachBaloon, :count).by(1)
      end

      it "assigns a newly created speach_baloon as @speach_baloon" do
        post :create, :speach_baloon => valid_attributes
        assigns(:speach_baloon).should be_a(SpeachBaloon)
        assigns(:speach_baloon).should be_persisted
      end

      it "redirects to the created speach_baloon" do
        post :create, :speach_baloon => valid_attributes
        response.should redirect_to(SpeachBaloon.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved speach_baloon as @speach_baloon" do
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBaloon.any_instance.stub(:save).and_return(false)
        post :create, :speach_baloon => {}
        assigns(:speach_baloon).should be_a_new(SpeachBaloon)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBaloon.any_instance.stub(:save).and_return(false)
        post :create, :speach_baloon => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested speach_baloon" do
        speach_baloon = SpeachBaloon.create! valid_attributes
        # Assuming there are no other speach_baloons in the database, this
        # specifies that the SpeachBaloon created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        SpeachBaloon.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => speach_baloon.id, :speach_baloon => {'these' => 'params'}
      end

      it "assigns the requested speach_baloon as @speach_baloon" do
        speach_baloon = SpeachBaloon.create! valid_attributes
        put :update, :id => speach_baloon.id, :speach_baloon => valid_attributes
        assigns(:speach_baloon).should eq(speach_baloon)
      end

      it "redirects to the speach_baloon" do
        speach_baloon = SpeachBaloon.create! valid_attributes
        put :update, :id => speach_baloon.id, :speach_baloon => valid_attributes
        response.should redirect_to(speach_baloon)
      end
    end

    describe "with invalid params" do
      it "assigns the speach_baloon as @speach_baloon" do
        speach_baloon = SpeachBaloon.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBaloon.any_instance.stub(:save).and_return(false)
        put :update, :id => speach_baloon.id, :speach_baloon => {}
        assigns(:speach_baloon).should eq(speach_baloon)
      end

      it "re-renders the 'edit' template" do
        speach_baloon = SpeachBaloon.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBaloon.any_instance.stub(:save).and_return(false)
        put :update, :id => speach_baloon.id, :speach_baloon => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested speach_baloon" do
      speach_baloon = SpeachBaloon.create! valid_attributes
      expect {
        delete :destroy, :id => speach_baloon.id
      }.to change(SpeachBaloon, :count).by(-1)
    end

    it "redirects to the speach_baloons list" do
      speach_baloon = SpeachBaloon.create! valid_attributes
      delete :destroy, :id => speach_baloon.id
      response.should redirect_to(speach_baloons_url)
    end
  end

end
